//-----------------------------------------------------------------------------
// aggPred.java
// package: FileServer
// 
// comando con cui si aggiorna un nodo predecessore all'avvio se mentre non era 
// attivo c' stato l'inserimento di un nuovo nodo
//
// data: 29-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class aggPred extends Comando{

   gestReteAnello gR;
   InetAddress newServer;
   int inPortNewServ;

   public aggPred( InetAddress newServer, /*int portNewServer,*/ int inPortNewServer ) {
      super( "aggPred" );
      this.newServer = newServer;
      this. inPortNewServ = inPortNewServ;
   }//aggPred
   
   public void set( gestore gs ) {
      this.gR = (gestReteAnello) gR;
   }//set
   
   public void run() {
      //aggiornamento nodo
      gR.succ2Add = newServer;
      gR.succ2Port = inPortNewServ;
      if (DbFS.cmdRete) DbFS.outMexLn(getName()+"\nsucc2="+gR.succ2Add+
         "\nsucc="+gR.succAdd+"\npred="+gR.pred);
      if (DbFS.cmdRete) DbFS.outMexLn("(aggPred): salvataggio configurazione ("+
         gR.fileConfig+")" );
      try {
         gR.saveConnOut( gR.fileConfig );
      } catch (Exception e) {
         if (DbFS.cmdRete) 
            DbFS.outMexLn("(aggPred)Eccezione salvataggio nuova configurazione "+e);
      }
   }//run
   
}//aggPred
