//-----------------------------------------------------------------------------
// aggSucc.java
// package: FileServer
// 
// comando con cui si aggiorna un nodo successore caduto
//
// data: 29-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class aggSucc extends Comando{
   
   gestReteAnello gR;
   InetAddress newServer;
   int portNewServ;

   public aggSucc( InetAddress newServer, int portNewServ ) {
      super( "aggSucc" );
      this.newServer = newServer;
      this.portNewServ = portNewServ;   
   }//newSucc

   public void set( gestore gR ){
      this.gR = ( gestReteAnello ) gR;
   }//set
   
   public void run() {
      //aggiornamento nodo
      gR.pred = newServer;
      gR.portServPred = portNewServ;
      if (DbFS.cmdRete) DbFS.outMexLn("(aggSucc): salvataggio configurazione ("+
         gR.fileConfig+")" );
      try {
         gR.saveConnOut( gR.fileConfig );
      } catch (Exception e) {
         if (DbFS.cmdRete) 
            DbFS.outMexLn("(aggSucc)Eccezione salvataggio nuova configurazione "+e);
      }
      if (DbFS.cmdRete) DbFS.outMexLn(getName()+" aggiornato nodo: pred="+gR.pred);
   }//run
   
}//aggSucc
