//-----------------------------------------------------------------------------
// client.java
// package: FileServer
// 
// client 
//
// data: 25-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import io.*;
   

public class client{
   
   String logName = "";
   int cmd = 0;
   
   public client() {}
   
   public static void main(String args[]) {
      //args[0]: IP server
      //args[1]: porta interprete client su server
      //args[2]: porta client
  	   PipedInputStream pipeR = new PipedInputStream( );
 	   winIOobj win = new winIOobj( pipeR, String.valueOf( args[2] ) );
      try {
         client cT = new client();
         new gestSock( Integer.parseInt( args[2] ), cT, win );
	      ObjectInputStream inObj = new ObjectInputStream( pipeR );
	      //creazione socket invio datagrammi
	      DatagramSocket sock = new DatagramSocket( Integer.parseInt( args[2] ) );
	      sock.setSoTimeout( 5000 ); //timeout receive 5 sec
	      String str;
	      DatagramPacket pck;
         while (true) {
            str = (String) inObj.readObject();
            StringReader strR = new StringReader( str );
            StreamTokenizer strT = new StreamTokenizer( strR );
            strT.wordChars( (int)'.', (int)'.' );
            strT.wordChars( (int)':', (int)':' );
            strT.wordChars( (int)'/', (int)'/' );
            strT.wordChars( (int)'0', (int)'9' );
            strT.nextToken();
            if ( strT.ttype == StreamTokenizer.TT_NUMBER && strT.nval == 200 ) {
               strT.nextToken();
               if ( strT.ttype == StreamTokenizer.TT_WORD ) {
                  cT.logName = strT.sval;
                  cT.cmd = 200;
                  win.mexLine.append("Nome logico richiesto: "+strT.sval+"\n" );
               }
            } else {
               cT.logName = "lista.txt";
               cT.cmd = 300;
            }
            pck = new DatagramPacket( str.getBytes(), str.length(), 
                        InetAddress.getByName( args[0] ), Integer.parseInt( args[1] ) );
            sock.send( pck );
 	         win.mexLine.append("Spedito comando ("+str+")"+"\n");
	         try {
	            byte buffRead[] = new byte[4];
	            DatagramPacket pckRead = new DatagramPacket( buffRead, 4 );
	            sock.receive( pckRead );
   	         win.mexLine.append("Ricevuto codice ("+ new String( pckRead.getData() ) +
	               ")" +"\n");
	         }
	         catch (Exception e) {
	            win.mexLine.append("receive sbloccata"+"\n");
	         }
         }
      } catch ( Exception e ) {
         win.mexLine.append("(Client): Eccezione " + e.toString() +"\n");
      }
   }//main 

}//client

class gestSock extends Thread {
   //gestisce le socket per la ricezione di file e lista file
   
   int port;
   client cT;
   winIOobj win;
      
   public gestSock( int port, client cT, winIOobj win ) {
      super();
      this.port = port;
      this.cT= cT;
      this.win = win;
      start();
   }//gestSock

   public void run() {
      boolean leggi = false;
      byte dati[] = new byte[ 4096 ];
      try {
         ServerSocket ser = new ServerSocket( port );
         win.mexLine.append("ser="+ser+"\n");
      while (true) {
         try {
            win.mexLine.append("In attesa di connessione"+"\n");
            Socket s = ser.accept();
            win.mexLine.append("Accettata nuova connessione da IP:"+s.getInetAddress()+
               "; port:"+s.getPort() +"\n");
            BufferedInputStream b = new BufferedInputStream( s.getInputStream() );
            leggi = false;
            if ( cT.cmd == 200 ) {
               //lettura nome logico file ( 50 byte )
               int oldPos = 0;
               int nletti = b.read( dati, 0, 50 );
               while ( nletti + oldPos < 50 ) {
                  oldPos = nletti;
                  nletti = b.read( dati, oldPos, 50 ); 
               }
               String log = new String( dati, 0, 50 );
               StringReader logS = new StringReader( log );
               StreamTokenizer strT = new StreamTokenizer( logS );
               strT.wordChars( (int)'.', (int)'.' );
               strT.wordChars( (int)':', (int)':' );
               strT.wordChars( (int)'/', (int)'/' );
               strT.wordChars( (int)'0', (int)'9' );
               strT.nextToken();
               if ( strT.sval.equals( cT.logName ) ) {
                  win.mexLine.append("Nome logico file: " + cT.logName +"\n" );
                  leggi = true;
               }
            }
            else leggi = true;
            if ( leggi ) {
               //apertura file su cui scrivo in locale (per ora nameDefault )
               FileOutputStream f = new FileOutputStream( cT.logName );
               int letTot=0;
               try {
                  int nread = b.read( dati, 0, 4096 );
                  while ( nread != -1 ) {
                     letTot = letTot + nread;
                     f.write( dati, 0, nread );
                     nread = b.read( dati, 0, 4096 );
                  }
               }
               catch ( Exception fexp ) {
                  win.mexLine.append("(Client): Eccezione "+fexp.toString()+")" +"\n");
               }
               finally {
                  win.mexLine.append("Finita ricezione (n."+String.valueOf(letTot)+" bytes"+")\n");
                  f.close();
                  s.close();
               }
            }
            //else risposta a richiesta precedente
         }
         catch( Exception e) {
            win.mexLine.append("(Client) (gestSock): Eccezione "+e.toString() +"\n");
         }
      }
      } catch (Exception e) {
         win.mexLine.append("(Client): Eccezione "+e.toString() +"\n");
      }
   }//run

}//gestSock
