//-----------------------------------------------------------------------------
// cmdProva.java
// package: FileServer
// 
// simulazione di comando; viene utilizzata nei test dei moduli
//
// data: 15-01-2000
// data: 05-02-2000 introduzione dell'indirizzo del nodo di affaccio
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;

public class cmdProva extends Comando {

      public trasm tr;   //trasmettitore da usare per la propagazione
      public String str;
      public InetAddress add = null; //IP di affaccio del comando
      public boolean affaccio;
      public int passi;
      
      public cmdProva( InetAddress add, boolean affaccio ) {
         super( "cmdProva" );
         str = new String("");
         this.add = add;
         this.affaccio = affaccio;
      }//cmdProva
      
      public cmdProva( String str ) throws Exception {
         super( "cmdProva");
         this.str = str;
         add = InetAddress.getLocalHost();
         affaccio = true;
      }//cmdProva
      
      public cmdProva( InetAddress add, boolean affaccio, String str ) {
         super("cmdProva");
         this.str = str;
         this.add = add;
         this.affaccio = affaccio;
      }//cmdProva
      
      public cmdProva( InetAddress add, boolean affaccio, String str, int passi ) {
         super("cmdProva");
         this.str = str;
         this.add = add;
         this.affaccio = affaccio;
         //serve per l'uso in locale (testing)
         this.passi = passi;
      }//cmdProva
      
      public void set( gestore gs ) {
         this.tr = gs.tr;
      }//set
      
      public String toString() {
         return "Comando " + str;
      }//toString

      public void run() {
         System.out.println("cmdProva: eseguito (" + str + ")" );
         InetAddress localAdd;
         try {
            localAdd = InetAddress.getLocalHost();
            if ( !add.equals( localAdd ) || affaccio 
               // test in locale
               || passi < 3 
            ) {
               System.out.println("cmdProva: propagazione del comando (" + str +") "+
                  "inviato dal nodo " + add.toString() );
               tr.invia( new cmdProva( add, false, " p("+ str + ")", passi+1 ) );
            }
            else System.out.println("cmdProva: il comando (" + str +
                  ") ha fatto un giro" + " completo dell'anello"); 
         } catch( Exception e ) { }
      }//run 

}//cmdProva
