//-----------------------------------------------------------------------------
// gestRit.java
// package: FileServer
// 
// thread di gestione delle ritrasmissioni
//
// data: 22-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;

public class gestRit extends Thread {

   ric r;      //richiesta da gestire
   gestAnelloNS gs;
   int num;    //numero di ritrasmissioni effettuate

   public gestRit( ric r, gestore gs ) {
      this.r = r;
      this.gs = (gestAnelloNS) gs;
      num = 0;
      start();
   }//gestRic
   
   public void run() {
      String s = new String("");
      ric ricLetta;
      boolean esci = false;
         try {
            if (!gs.operNS) {
               if (DbFS.gestRit) 
                  DbFS.outMexLn("(gestRit) wait in attesa operNS=true");
               gs.ns.wait();
               if (DbFS.gestRit) 
                  DbFS.outMexLn("(gestRit) sbloccato da wait");
            }
         } catch (Exception e) {
            
         }
         while( !esci ) {
            try {
               InetAddress thisAdd = InetAddress.getLocalHost();
               synchronized( s ) {
                  s.wait( gestAnelloNS.timeOut * (num+1) );
                  synchronized( gs.ns.prop ) {
                     //controllo della presenza della richiesta
                     synchronized ( gs.ns ) {
                        ricLetta = gs.ns.ricProp( r );
                     }
                     if ( !ricLetta.isNull() && ricLetta.op==r.op ) {
                        //invio della richiesta
                        if (r.op)
                           //inserimento
                           gs.propaga( new insLoc( false, thisAdd, gs.inPort, r ),
                              new elemAgg( r, thisAdd, gs.inPort ) );
                        else 
                           //cancellazione
                            gs.propaga( new cancella( false, thisAdd, r ),
                              new elemAgg( r, thisAdd, gs.inPort ) );
                        num++;
                     }
                     else esci = true;
                  }
               }
            } catch( Exception e ) {
            }
         }
   }//run

}//gestRic