//-----------------------------------------------------------------------------
// gestore.java
// package: FileServer
// 
// superclasse dei gestori dei server
//
// data: 15-01-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;

public abstract class gestore {

   public nameServer ns; //name Server
   protected intServer  is; //interprete server
   protected intClient  iC; //interprete cliente
   protected intNewServer iNs; //interprete nuovi server
   protected trasm      tr; //trasmettitore da gestire
   protected Vector     inSock; //tabella delle socket di ingresso
   protected Vector     outSock;//tabella delle socket di uscita
 
   protected abstract void loadConnOut( String fileConfig ) throws Exception;
      //metodo astratto per il ripristino dello stato del server 
  
   protected abstract void saveConnOut( String fileConfig ) throws Exception;
      //metodo astratto per il salvataggio dello stato del server
      
   public abstract void notifyCrashOut( int ind, Comando cmd ) ;

   public abstract void notifyCrashIn( int ind ) ;

   public abstract void newInSocket( Socket sIn );
   
   public abstract void newOutSocket( Socket sOut ); 
     
}//gestore