//-----------------------------------------------------------------------------
// intNewServer.java
// package: FileServer
// 
// interprete dei comandi dai nuovi server
//
// data: 19-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;
import java.util.*;
import io.*;         //serve nel main per l'uso della finestra di input

public class intNewServer extends intDat {

// Tabella dei comandi
// Comando         Metodo
// ----------------------
// 500             cmd500   richiesta di ingresso nell'anello
// 000             cmd000   gestione comando inesistente  
  
   
   public intNewServer( gestReteAnello gR ) throws SocketException {
      super( gR );
      //creazione della socket
      if (DbFS.intClient) DbFS.outMexLn("intNewServer: agganciato alla porta "+
         String.valueOf( gR.portServer ) );
      sock = new DatagramSocket(  gR.portServer );
      dati = new byte[ lungDati ];
      com = new Vector( 2, 1 );
      met = new Vector( 2, 1 );
      Class prm[] = new Class[ 2 ];
      try { 
         prm[0] = Class.forName( "java.io.StreamTokenizer" ); 
         prm[1] = Class.forName( "java.net.DatagramPacket" ); 
         Class thisClass = Class.forName( "FileServer.intNewServer" );
         com.addElement( new Integer( 500 ) );   //comando di ricerca
         met.addElement( thisClass.getDeclaredMethod( "cmd500", prm ) );
         prm = new Class[ 1 ];
         prm[0] = Class.forName( "java.net.DatagramPacket" );
         com.addElement( new Integer( 0 ) ) ;    //comando inesistente
         met.addElement( thisClass.getDeclaredMethod( "cmd000", prm ) );
         start();
      }
      catch ( Exception e ) { 
         if (DbFS.intClient) DbFS.outMexLn("intNewServer: Eccezione "+e.toString() );
      }
   }//intNewServer
   
   void cmd500( StreamTokenizer str, DatagramPacket pck ) {
      if (DbFS.intNewServer) DbFS.outMexLn("intNewServer: gestione comando di ingresso");
      //viene ignorato tutto quanto si trova dopo il codice del comando
      InetAddress addNs = pck.getAddress(); //IP nuovo server
      if (DbFS.intNewServer) DbFS.outMexLn("intNewServer: addNS="+addNs);
      int         portNs = pck.getPort();   //porta nuovo server (TCP==UDP)
      if (DbFS.intNewServer) 
         DbFS.outMexLn("intNewServer: portNS="+String.valueOf( portNs ) );
      cmd500Class c = new cmd500Class( addNs, portNs );
      c.set( gs );
      c.crea();
   }//cmd500
   
   void cmd000( DatagramPacket pck ) {
      if (DbFS.intNewServer) DbFS.outMexLn("intNewServer: gestione comando inesistente");
   }//cmd000

}//intNewServer
