//-----------------------------------------------------------------------------
// trasmPatch.java
// package: FileServer
// 
// gestore della tabella di trasmissione e della trasmissione dei 
// comandi sulla rete dei server; patch per il problema del rilevamento
// caduta socket
//
// data: 26-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;
import java.io.*;
import java.util.*;

public class trasmPatch extends trasm {

   Vector ascolto;

   public trasmPatch ( gestore gs, int dim, int inc ) {
      super( gs, dim, inc );
      ascolto = new Vector( dim, inc );
   }//trasmPatch
   
   public synchronized void insPatch( socketPatch sP ) {
      ascolto.addElement( sP );
   }//insPatch
   
   public synchronized void canc( int indice ) {
      super.canc( indice );
      ascolto.removeElementAt( indice );
   }//canc

}//trasmPatch

class socketPatch extends Thread {

   protected Socket in;
   protected gestore gs;
   protected trasmPatch tr;

   public socketPatch( Socket in, gestore gs ) {
   //thread per la gestione dell' ascolto dell asocket di uscita 
      super( );
      this.in = in;
      this.gs = gs;
      tr = ( (trasmPatch) gs.tr );
      start();
   }//socketPatch

   public void run() {
      try { 
            ObjectInputStream inS = new ObjectInputStream( in.getInputStream() );
            inS.readObject();
            if (DbFS.socketPatch) DbFS.outMexLn("socketPatch: sbloccata readObject()");
      } catch ( Exception e ) {
         if (DbFS.socketPatch) DbFS.outMexLn("socketPatch: Eccezione "+e.toString());
         int index = tr.ascolto.indexOf( this );
         if ( DbFS.socketPatch ) 
            DbFS.outMexLn("socketPatch: crash socket uscita indice " +
            String.valueOf( index ) );
         gs.notifyCrashOut( index, null );
      }
   }//run
  
}//socketPatch
