//-----------------------------------------------------------------------------
// mainNS.java
// package: provaFS
// 
// modulo di test per il gestore del servizio di nomi ( locale )
//
// data: 20-02-2000 
//-----------------------------------------------------------------------------

package provaFS;

import FileServer.*;

public class mainNS {

   public static void newNS( String name ) throws Exception  {
      nameServer.newNSvuoto( name );
      System.out.println("Creato name server vuoto: "+ name );
   }//newNS

   public static void main ( String args[] ) {
   //creazione di un nuovo name server
   //args[0]: nome name server da creare (senza estensione)
   //args[1]: nome fisico1
   //args[2]: nome logico1
   //...
   //args[ 2*n + 1 ] : nome fisico n+1
   //args[ 2*(n+1) ] : nome logico n+1
      try {
         DbFS.OpenDbgWin("mainNS");
         nameServer.newNSvuoto( args[0] );
         nameServer ns = new nameServer( args[0] );
         for ( int i = 1; i< args.length; i = i + 2 ) {
            pathName path = new pathName( args[i+1] );
            ns.inserisci( args[i], path );
            System.out.println( args[i] + path.toString() );
         } 
         ns.salva();
      } catch ( Exception e ) {
         System.out.println("Eccezione: "+e.toString() );
      }
      finally {
         DbFS.CloseDbgWin();
      }
   }//main

}//mainNS