//-----------------------------------------------------------------------------
// Comando.java
// package: FileServer
// 
// classe astratta radice della gerarchia delle classi delle rappresentazioni
//	interne dei comandi 
//
// data: 29-12-99
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;

public abstract class Comando extends Thread implements Serializable{

	protected static ThreadGroup comGroup = new ThreadGroup( "Comando" );
	
	//Codici dei comandi
	public static String Ricerca 	= "200";
	public static String Lista 	= "300";
	public static String NewEntry = "500";
	public static String InsDistr = "InserimentoNS";
	public static String CancDistr ="CancellazioneNS";
	public static String aggiorna = "AggiornamentoNS";
	public static String newServer= "InsNewServer";
	
	
	//Codici di risposta al cliente
	public static String CmdInesistente =   "1200";
	public static String PathScorretto =    "1300";
	public static String SintassiScorretta ="1400";
	public static String FileNonPresente =  "1500";
	
	
	public Comando( String name ) {
		super( Comando.comGroup, name );
	}//Comando
	
	public abstract void set( gestore gs );
	
}//Comando