// --------------------------------------------------------------------------------------------
// DbgFS.java
// Gestione dei messaggi a video per la gestione del FileServer
// Definizione dell'interfaccia grafica per il debug
//
// data: 05-02-2000
// --------------------------------------------------------------------------------------------

package FileServer;

import java.awt.*;
import java.awt.event.*;
import Debug;

public class DbgFS extends Debug {

   Panel puls2;   //Pannello contenente la seconda riga di pulsanti
   String Strasm = "Trasm";
   String SintServer = "IntServer";
   String SinSock = "InSock";
   String SoutSock = "OutSock";
   gestore gs;
   boolean enable; //true quando il gestore  stato settato

   public DbgFS( String debug ) {
      super( debug );
      enable = false;
      Button Btrasm = new Button( Strasm );
      Button BintServer = new Button( SintServer );
      Button BinSock = new Button( SinSock );
      Button BoutSock = new Button( SoutSock );
		Btrasm.addActionListener( new tabella( this, Btrasm ) );
		BintServer.addActionListener( new tabella( this, BintServer ) );
		BinSock.addActionListener( new tabella( this, BinSock ) );
		BoutSock.addActionListener( new tabella( this, BoutSock ) );
      puls2 = new Panel();
 		puls2.setLayout( new GridLayout( 1, 5 ) );
		Label tab = new Label("Tabella");
		tab.setAlignment( Label.CENTER );
      puls2.add( tab );
		puls2.add( Btrasm );
		puls2.add( BintServer );
		puls2.add( BinSock );
		puls2.add( BoutSock );
		opz.setLayout( new GridLayout( 2, 1 ) );
		opz.add( puls );
		opz.add( puls2 );
		add( opz, BorderLayout.NORTH );
   }//DbgFS
   
   public void setGestore( gestore gs ) {
      this.gs = gs;
      enable = true;
   }//setGestore
   
 	protected class tabella implements ActionListener {
	
		DbgFS dg;	//finestra da controllare 
		Button ctr; //bottone tabella da gestire
				
		public tabella( DbgFS dg, Button ctr ) {
			this.dg = dg;
			this.ctr = ctr;
		}//tabella
		
		public void actionPerformed( ActionEvent e ) {
		   if ( enable ) {
    		   if  ( ( ctr.getLabel() ).equals( Strasm ) ) {
   		       mexLine.setText("Visualizzata tabella di trasmissione");
   		       area.append( "Tabella trasm\n" + gs.tr.toString() + "\n\n" );
   		   }
   		   else 
   		      if (( ctr.getLabel() ).equals( SintServer ) ) {
   	            mexLine.setText("Visualizzata tabella di ricezione server");
   	            area.append( "Tabella intServer\n" + gs.is.toString() + "\n\n" );
   		      }
   		      else
   		         if (( ctr.getLabel() ).equals( SinSock ) ) {
   		             mexLine.setText("Visualizzata tabella socket di ingresso");
   		             int i = 0;
   		             area.append("Tabella delle socket di ingresso\n");
		                while ( i < gs.inSock.size() ) {
   		                area.append( String.valueOf(i) + ": " +
		                      gs.inSock.elementAt( i ).toString() + "\n" );
                         i++;
                      }
                      area.append("<fine>\n\n");
   		         }
   		         else {
   		             mexLine.setText("Visualizzata tabella socket di uscita");
   		             int i = 0;
   		             area.append("Tabella delle socket di uscita\n");
   		             while ( i < gs.outSock.size() ) {
   		                area.append( String.valueOf(i) + ": " +
		                      gs.outSock.elementAt( i ).toString() + "\n" );
                         i++;
                      }
                      area.append("<fine>\n\n");
   		         }
		   }
		   else mexLine.setText("Non  ancora stato impostato un gestore");
		}//actionPerfomed
		
	}//tabella

   
   public static void main( String args[] ) {
      (new DbgFS("prova")).setVisible(true);
   }//main

}//DbgFS