//-----------------------------------------------------------------------------
// MultiClientTest.java
// package: FileServer
// 
// client per il test del server
//
// data: 25-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.net.*;

public class MultiClientTest{

   public static void main( String args[] ) {
      //args[0]: numero di clienti da creare
      //args[1]: porta client da cui partire
      //args[2]: numero di richieste per ogni client
      //args[3]: numero server
      //args[4]: IP server 1
      //args[5]: porta server 1
      //...
      //args[3+(numero server)]: IP ultimo server
      //args[4+(numero server)]: porta ultimo server 
      //args[4+(numero server)*2]: timeout (opzionale)
      try {
         int nCl = Integer.parseInt( args[0] );
         int base = Integer.parseInt( args[1] );
         int nIter = Integer.parseInt( args[2] );
         int nServ = Integer.parseInt( args[3] );
         int timeout;
         if (args.length==(nServ*2+4+1)) timeout = Integer.parseInt( args[4+2*nServ] );
            else timeout = 10000;
         System.out.println("N.clienti="+args[0]+"; nServer="+args[3]+
            "; nIter="+args[2]+"; timeout="+args[nServ*2+4] );
         clientTest cT[] = new clientTest[ nCl ];
         for( int i=0; i<nCl; i++ )  {
            //creazione dei processi client
            cT[ i ]= new clientTest( InetAddress.getByName( args[4+2*(i%nServ)] ), 
               Integer.parseInt( args[5+2*(i%nServ)] ), nServ, base+i, nIter, timeout );
         }
         for( int i=0; i<nCl; i++ ) 
            cT[i].join();
         System.out.println("Finita esecuzione di tutti i processi");
      } catch( Exception e ) {
         System.out.println("Eccezione: "+e);
      }
   }//main

}//MultiClientTest