//-----------------------------------------------------------------------------
// aggiorna.java
// package: FileServer
// 
// comando di aggiornamento del name server locale di un nodo precedentemente
// caduto
//
// data: 23-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.util.*;

public class aggiorna extends Comando {

   protected Vector ricTab;
   protected gestAnelloNS gs;

   public aggiorna( Vector ricTab ) {
      super( aggiorna );
      this.ricTab = ricTab;
   }//aggiorna
   
   public void set( gestore gs ) {
      this.gs = (gestAnelloNS) gs;
   }//set
   
   public void run() {
      if (DbFS.aggiorna)
         DbFS.outMexLn("CMDaggiorna: metodo run");
      elemAgg e;
      if (DbFS.aggiorna)
         DbFS.outMexLn("CMDaggiorna: ns="+gs.ns.toString());
      synchronized( gs.ns ) {
         if ( !gs.operNS ) {
            if (DbFS.aggiorna)
               DbFS.outMexLn("CMDaggiorna: inizio invio tabella aggiornamento");
            while( ricTab.size() > 0 ) {
               //lettura prima richiesta della tabella
               e = ( elemAgg ) ricTab.elementAt( 0 );
               if (DbFS.aggiorna)
                  DbFS.outMexLn("CMDaggiorna: letto da tabella e="+e.toString() );
               ricTab.removeElementAt( 0 );
               if ( e.r.op ) {
                  //inserimento
                  if (DbFS.aggiorna) 
                     DbFS.outMexLn("CMDaggiorna: inserito e="+e.toString() );
                  insLoc ins = new insLoc( false, e.mittente, e.inPort, e.r );
                  ins.set( gs );
                  ins.metodo();
               }
               else {
                  //cancellazione
                  if (DbFS.aggiorna) 
                     DbFS.outMexLn("CMDaggiorna: cancellato e="+e.toString() );
                  cancLoc canc = new cancLoc( false, e.mittente, e.inPort, e.r );
                  canc.set( gs );
                  canc.metodo();
               }
            }
            gs.operNS = true;   //name server aggiornato
            if (DbFS.aggiorna)
               DbFS.outMexLn("CMDaggiorna: finito aggiornamento tabella; operNS="+
               String.valueOf( gs.operNS ) );
            gs.ns.notifyAll();
         }
      }
   }//run

}//aggiorna
