//-----------------------------------------------------------------------------
// cmd300Class.java
// package: FileServer
// 
// comando di lista
//
// data: 25-02-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.net.*;

public class cmd300Class extends Comando {

   trasm       tr;
   nameServer  ns;
   intClient   iC;

   InetAddress addC;   //IP cliente
   int         portC;  //porta a cui inviare la lista al cliente
   
   public cmd300Class( InetAddress addC, int portC ) {
      super( Lista );
      this.addC = addC;
      this.portC = portC;
   }//cmd300Class

   public void set( gestore gs ) {
      this.tr = gs.tr;   //aggancio trasmettitore
      this.ns = gs.ns;   //aggancio nameServer
      this.iC = gs.iC;   //aggancio interprete cliente
      if (DbFS.cmd300Class) 
         DbFS.outMexLn(getName()+": cmd300Class set( gestore gs ) ");
   }//set
   
   public void run() {
      try {
         //creazione socket di invio lista al cliente
         Socket s = new Socket( addC, portC );
         PrintWriter sOut = new PrintWriter( s.getOutputStream() );
         //lettura lista da nameServer
         String lista[] = ns.listaLogico();
         for ( int i=0; i<lista.length; i++ ) {
            sOut.print( lista[i] );
            sOut.print( '\n' );
            if (DbFS.cmd300Class) 
               DbFS.outMexLn(getName()+": cmd300Class inviato "+lista[i]);
         }
         sOut.flush();
         if (DbFS.cmd300Class) 
            DbFS.outMexLn(getName()+": cmd300Class inviata lista");
         s.close();
         sOut.close();
      }
      catch (Exception e) {
         if (DbFS.cmd300Class) 
            DbFS.outMexLn(getName()+": Eccezione "+e.toString() );
      }
   }//run

}//cmd300Class