//-----------------------------------------------------------------------------
// servRetePanel.java
// package: FileServer
// 
// console per la gestione della rete
//
// data: 01-03-2000
//-----------------------------------------------------------------------------

package FileServer;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class servRetePanel extends Panel{

   protected gestReteAnello gs;
   public static String nullo = "Sconosciuto";
   
   Label inPort, outPort, succAdd, succPort, succServ, succ2Add, succ2Port, succ2Serv;
   Label pred, predServ, pred2Serv, portServ, portClient, disp;

   public servRetePanel( gestReteAnello gs ) {
      super();
      this.gs = gs;
      //init label
      inPort = new Label();
      outPort = new Label();
      disp = new Label();
      succAdd = new Label();
      succPort = new Label();
      succServ = new Label();
      succ2Add = new Label();
      succ2Port = new Label();
      pred = new Label();
      predServ = new Label();
      pred2Serv = new Label();
      portServ = new Label();
      portClient = new Label();
      refresh();
      initWin();
   }//servRetePanel
   
   public servRetePanel() {
      this( null );
   }//servRetePanel
   
   protected Label etichGray( String name ) {
      Label lbl = etich( name );
      lbl.setBackground( Color.lightGray );
      lbl.setForeground( Color.black );
      return lbl;
   }//etichGray
   
   protected Label etich( String name ){
      Label lbl = new Label( name );
      lbl.setAlignment( Label.CENTER );
      lbl.setForeground( Color.gray );
      return lbl;
   }//etich
   
   protected Label valore( Label lbl ) {
      lbl.setAlignment( Label.CENTER );
      return lbl;
   }//valore
   
   protected String s( int num ) {
      return String.valueOf( num );
   }//s
   
   protected void refresh() {
      if ( gs.disp )
         disp.setText("Presente");
      else 
         disp.setText("Non Presente");
      inPort.setText( s( gs.inPort) );
      outPort.setText( s( gs.outPort ) );
      if ( gs.succAdd != null )
         succAdd.setText( gs.succAdd.toString() );
      else 
         succAdd.setText( nullo );
      succPort.setText( s( gs.succPort ) );
      succServ.setText( s( gs.portServSucc ) );
      if ( gs.succ2Add != null )
         succ2Add.setText( gs.succ2Add.toString() );
      else 
         succ2Add.setText( nullo );
      succ2Port.setText( s( gs.succ2Port ) );
      if ( gs.pred != null )
         pred.setText( gs.pred.toString() );
      else 
         pred.setText( nullo );
      predServ.setText( s( gs.portServPred ) );
      pred2Serv.setText( s( gs.portServPred2 ) );
      portServ.setText( s( gs.portServer ) );
      portClient.setText( s ( gs.portClient ) );
   }//refresh
   
   protected void initWin() {
      setLayout( new BorderLayout() );
      Panel display = new Panel(new GridLayout( 0, 2 ));
      display.add( etichGray( "Nodo corrente:") );
      display.add( new Panel() );
      display.add( etich( "porta ingresso:" ) );
      display.add( valore( inPort ) );
      display.add( etich( "porta uscita:" ) );
      display.add( valore( outPort ) );
      display.add( etich( "porta Client:" ) );
      display.add( valore( portClient ) );
      display.add( etich( "porta Server:" ) );
      display.add( valore( portServ ) );
      display.add( etichGray( "Nodo Successore:" ) );
      display.add( valore( disp ) );
      display.add( etich( "IP:" ) );
      display.add( valore( succAdd ) );
      display.add( etich( "porta ingresso:" ) );
      display.add( valore( succPort ) );
      display.add( etich( "porta Server:" ) );
      display.add( valore( succServ ) );
      display.add( etichGray("Nodo Successore 2:" ) );
      display.add( new Panel() );
      display.add( etich( "IP:" ) );
      display.add( valore( succ2Add ) );
      display.add( etich( "porta ingresso:" ) );
      display.add( valore( succ2Port ) );
      display.add( etichGray( "Nodo Predecessore:" ) );
      display.add( new Panel() );
      display.add( etich( "IP:" ) );
      display.add( valore( pred ) );
      display.add( etich( "porta Server:" ) );
      display.add( valore( predServ ) );
      display.add( etichGray( "Nodo Predecessore 2:" ) );
      display.add( new Panel() );
      add(display, BorderLayout.CENTER);
      display.add( etich( "porta Server:" ) );
      display.add( valore( pred2Serv ) );
      Panel puls = new Panel( new GridLayout( 1,5 ) );
      Button agg = new Button( "Aggiorna" );
      puls.add( agg );
      puls.add( new Panel() );
      puls.add( new Panel() );
      puls.add( new Panel() );
      puls.add( new Panel() );
 	   agg.addActionListener( new refr( this ) );
	   add( puls, BorderLayout.NORTH );
      setVisible(true);
   }//initWin
   
   public static void main( String args[] ) {
      Frame f = new Frame("prova");
      f.add( new servRetePanel( ) );
      f.setSize( 500, 400 );
      f.setVisible( true );
   }//main

}//servRetePanel

class refr implements ActionListener {
	
	servRetePanel dg;   //finestra da controllare 
	
	public refr ( servRetePanel dg ) {
		this.dg = dg;
	}//refr
	
	public void actionPerformed( ActionEvent e ) {
	   dg.refresh();
	}//actionPerformed
	
}//refr	
